<template>
    <div v-if="paginationData" class="bg-white px-4 py-3 flex items-center justify-between border border-gray-200 sm:px-6" :class="wrapperClass">
        <div class="flex-1 flex justify-between sm:hidden">
            <a @click.prevent="sendLink(paginationData.prev_page_url)" href="#"
               class="relative inline-flex items-center px-4 py-2 border border-gray-300 text-sm font-medium rounded-md text-gray-700 bg-white hover:bg-gray-50">
                Next
            </a>
            <a @click.prevent="sendLink(paginationData.next_page_url)" href="#"
               class="ml-3 relative inline-flex items-center px-4 py-2 border border-gray-300 text-sm font-medium rounded-md text-gray-700 bg-white hover:bg-gray-50">
                Previous
            </a>
        </div>
        <div class="hidden sm:flex-1 sm:flex sm:items-center sm:justify-between">
            <div>
                <p class="text-sm text-gray-700">
                    Showing
                    <span class="font-medium">{{paginationData.from}}</span>
                    to
                    <span class="font-medium">{{paginationData.to}}</span>
                    of
                    <span class="font-medium">{{paginationData.total}}</span>
                    results
                </p>
            </div>
            <div>
                <nav class="relative z-0 inline-flex rounded-md -space-x-px" aria-label="Pagination">
                    <a href="#" @click.prevent="sendLink(paginationData.prev_page_url)"
                       class="relative inline-flex items-center px-2 py-2 rounded-l-md border border-gray-300 bg-white text-sm font-medium text-gray-500 hover:bg-gray-50">
                        <span class="sr-only">Previous</span>

                        <chevron-left svg-class="h-5 w-5"/>
                    </a>

                    <!-- Current: "z-10 bg-indigo-50 border-indigo-500 text-indigo-600", Default: "bg-white border-gray-300 text-gray-500 hover:bg-gray-50" -->
                    <a v-for="(link,index) in paginationData.links"  v-if="validateLink(index)" href="#"
                       @click.prevent="sendLink(link.url)"
                       :class="[{'z-10 text-white bg-blue-600' : link.active} , {'bg-white border-gray-300 text-gray-500 hover:bg-gray-50' : !link.active}]"
                       class="relative inline-flex items-center px-4 py-2 border text-sm font-medium"
                    >
                        {{link.label}}
                    </a>

                    <a :href="paginationData.next_page_url" @click.prevent="sendLink(paginationData.next_page_url)"
                       class="relative inline-flex items-center px-2 py-2 rounded-r-md border border-gray-300 bg-white text-sm font-medium text-gray-500 hover:bg-gray-50">
                        <span class="sr-only">Next</span>

                       <chevron-right svg-class="h-5 w-5"/>
                    </a>
                </nav>
            </div>
        </div>
    </div>

    <div v-else-if="links">
        <ul class="border border-gray-200 " :class="classWrapper">
            <li v-for="link in links">
                <a @click.prevent="sendLink(link.url)"
                   :class="[{'text-white bg-blue-600': link.active }, {'hover:text-white hover:bg-blue': !link.active }]"
                   class="block text-blue border-l border-grey-light px-3 py-2" :href="link.url" >

                    <template v-if="link.label.indexOf('Previous') !== -1">
                        <div>
                            Previous
                        </div>
                    </template>

                    <template v-else-if="link.label.indexOf('Next ') !== -1">
                        <div>
                            Next
                        </div>
                    </template>

                    <template v-else>
                        <div v-html="link.label">
                        </div>
                    </template>
                </a>
            </li>
        </ul>
    </div>
</template>

<script>
    import ChevronLeft from "../../svg/ChevronLeft";
    import ChevronRight from "../../svg/ChevronRight";
    export default {
        name: "Pagination",
        components: {ChevronRight, ChevronLeft},
        props: {
            nextPageUrl: {
                type: String,
                default: ''
            },
            previousPageUrl: {
                type: String,
                default: ''
            },
            links: {
                type: Array,
                default: function () {
                    return []
                }
            },
            paginationData: {
                type: Object,
                default: null
            },
            wrapperClass: {
                type: String,
                default: ''
            }

        },
        data() {
            return {
                extraCss: ''
            }
        },
        methods: {
            sendLink(link) {
                this.$emit('click', link)
            },
            validateLink(index){
                if (index === (this.paginationData.links.length -1))
                    return false;
                else if(index !== 0 )
                    return true;
                else
                    return false;
            }
        },
        computed: {
            classWrapper() {
                return [
                    'flex justify-end list-resetfont-sans',
                    this.wrapperClass
                ]
            },

        }
    }
</script>

<style scoped>

</style>